/* key.hh
 * Written by Joshua Rowe
 */

#ifndef	__REG_VAL_HH__
#define	__REG_VAL_HH__

class	RegVal;
typedef	RegVal *	pRegVal;

#include	"key.hh"

class	RegVal	: public pstreamable
{
  virtual char *	streamableName() const
    { return "RegVal"; }
protected:
  virtual pvoid		read(ipstream &is);
  virtual void		write(opstream &os);
public:
  char *		data;
  pRegKey		parent;
  pRegVal		next, prev;
  char *		name;
  RegVal(char *aname = 0, char *adata, pRegKey aparent = 0);
  RegVal(pstreamableInit);
  virtual		~RegVal();
  static pstreamable *	build();
  char *		getfullname();
  virtual void		init();
};

inline opstream &	operator<<(opstream &os, pRegVal d)
{
  return os << (pstreamable *)d;
}

inline ipstream &	operator>>(ipstream &is, pRegVal &d)
{
  return is >> (pvoid &)d;
}

__PSTREAM_LINK(RegRegVal)

#endif
